/*
** DefaultLanguage v1.0
**
** An automatic WWW language selector
**
** Copyright (c) 25.3.94 by Andreas Ley <ley@rz.uni-karlsruhe.de>
**
** Permission to use, copy, modify, and distribute this software for any
** purpose and without fee is hereby granted, provided that the above
** copyright notice appears in all copies. This software is provided "as is"
** and without any express or implied warranties.
**
** This program has been tested on a HP9000/720 with HP-UX A.08.07
** In this environment, neither lint -u nor gcc -Wall produce any messages.
** If you encounter any errors or need to make any changes to port it
** to another platform, please contact me.
**
** Version history
**
** Version 1.0 - 15.10.94
**	Initial version
*/

char header[]="defaultlanguage v1.0\n(c) 1994 by Andreas Ley\n";

/* General definitions */

#define	MASTER	"webmaster@rz.uni-karlsruhe.de"
#define	REFERENCE	"<A HREF=\"/~Andreas.Ley/\"><EM>Andreas Ley</EM></A>"
#define	DIRINDEX	"index.html"

/* File locations */

#define	CONFIG	"/usr/local/etc/httpd/config/defaultlanguage.conf"

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <regex.h>

#ifdef NEEDSTRERROR
extern int	sys_nerr;
extern char	*sys_errlist[];
#define	strerror(errno)	((errno)>=sys_nerr?"Undefined error":sys_errlist[errno])
#endif /* NEEDSTRERROR */

#define	FALSE	0		/* This is the naked Truth */
#define	TRUE	1		/* and this is the Light */


/* Functions from wildmat.c */

extern int wildmat();

/* Returns a Location: header */
void show_location(char *location)
{
	(void)printf("Location: %s\n",location);
	(void)printf("URI: %s\n\n",location);
}
		


void usage(char *image)
{
	(void)fprintf(stderr,"Usage: %s [-h] [-v]\n",image);
	exit(1);
}


int main(int argc, char *argv[])
{
	int	c;
	char	line[BUFSIZ],new_path[MAXPATHLEN];
	char	*language,*remote_host,*ptr,*nptr;
	FILE	*src;

	while ((c=getopt(argc,argv,"vh?")) != EOF)
		switch ((char)c) {
		case 'v':
			(void)fprintf(stderr,header);
			exit(0);
		case 'h':
			(void)fprintf(stderr,header);
		case '?':
			usage(argv[0]);
		}

	remote_host=getenv("REMOTE_HOST");
	language=NULL;
	if ((src=fopen(CONFIG,"r"))) {
		while(!language&&fgets(line,sizeof(line),src)) {
			ptr=strchr(line,'\0');
			if (*(ptr-1)=='\n')
				ptr--;
			if (*(ptr-1)=='\r')
				ptr--;
			while (ptr>line &&  *(ptr-1)==' ')
				ptr--;
			*ptr='\0';
			ptr=line;
			while(!strchr(" \t",*ptr))
				ptr++;
			*ptr++='\0';
			while(strchr(" \t",*ptr))
				ptr++;
			while(!language&&ptr) {
				nptr=strchr(ptr,',');
				if (nptr)
					*nptr++='\0';
				if (wildmat(remote_host,ptr))
					language=line;
				ptr=nptr;
			}
		}
		(void)fclose(src);
	}
	if (!language)
		language="en";

	strcpy(new_path,getenv("PATH_INFO"));
	if (!*new_path)
		strcpy(new_path,"/");
	if (new_path[strlen(new_path)-1]=='/')
		strcat(new_path,DIRINDEX);
	for (ptr=strchr(new_path,'\0');*ptr!='.';ptr--);
		memmove(ptr+strlen(language)+1,ptr,strlen(ptr));
	strncpy(ptr+1,language,strlen(language));
	show_location(new_path);

	return(0);
}
